
#include "TROOT.h"
#include "TVector3.h"

#include <deque>
#include <string>

#include "CDataHime.hh"
#include "CDataHimeSim.hh"
#include "CParticle.hh"

void Analysis(std::string filename, std::string method, Long64_t nentries = -1);

int GetFirstProtonInformation(CDataHimeSim* data, CParticle& proton);
void FoldChargedParticle(TVector3 momentum, CParticle& particle,
			 double dele, double estrag, double multi_theta);

//calculate simlation data to experiment data
void SimToExp(CDataHimeSim* simdata, CDataHime* dataexp, std::string method);

//analysis method for experiment data
void Track(CDataHime* dataexp);
void Simple(CDataHime* dataexp);
void Niren(CDataHime* dataexp);//not optimized

//#define VISUALIZE 1

#if 1
  //11Li, 2g/cm2, 230MeV
  double dele(0.18);
  double estrag(1.4);
  double multi_theta(sqrt((1.7*1.7+2.1*2.1)/2)*1e-3);
#elif 0
  //11Be, 1g/cm2, 250MeV
  double dele(24.69);
  double estrag(sqrt((1.3*1.3+1.0*1.0)/2));
  double multi_theta(sqrt((1.5*1.5+1.3*1.3)/2)*1e-3);
#elif 0
  //12B, 1g/cm2, 250MeV
  double dele(56.61);
  double estrag(sqrt((1.6*1.6+1.0*1.0)/2));
  double multi_theta(sqrt((1.7*1.7+1.3*1.3)/2)*1e-3);
#endif

static const Int_t rotation = 0;//lneutは普通

static const Double_t thr = 2.5;//3.0MeV相当
static const Double_t treso = 0.408;//0.289*sqrt(2), by fukuda-san D-thesis
static const Double_t attlength = 200.;
static const Double_t length = 214.;
static const Double_t vlength = 90.;
static const Double_t width = 6.;
static const Double_t depth = 6.;
static const Double_t gap = 32.4;
static const Double_t zdepth = 460.;
static const Double_t zdepth_back = 504.4;//used only for visualization
static const Double_t vl = 15.;
static const Double_t aminmin = 10.;
//static const Double_t aminmin = 100.;
static const Double_t ein = 70;
//static const Double_t sp = 15;
static const Double_t sp = 0;//ほとんどかわらない(Geant4では考慮されてない?)
static const Double_t shift = 50.;
static const double step = 300.;//bethe-blochで使う

//static const std::deque<CDataHime::OneData>::size_type multihit = 2;
static const std::deque<CDataHime::OneData>::size_type multihit = 3;
//static const std::deque<CDataHime::OneData>::size_type multihit = 4;
//static const std::deque<CDataHime::OneData>::size_type multihit = 5;
